#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# epost, v2.0
#

import sys
from unicodedata import normalize
import urllib, urllib.parse, urllib.request
import json
import xml.etree.ElementTree as ET

def send_request(q):
    params = {
        "ServiceKey": "uLEgvigbgUbygR4BPFLGjQLdxV78vuhfRZti20Xj9Gv+OhPvvkdsG6NiZs/OuFd76030lliGS+GAREtCBrBqcQ==",
        "srchwrd": q
    }
    url = "http://openapi.epost.go.kr/postal/retrieveNewAdressAreaCdSearchAllService/retrieveNewAdressAreaCdSearchAllService/getNewAddressListAreaCdSearchAll"
    url += "?"+urllib.parse.urlencode(params)

    return urllib.request.urlopen(url).read()

if __name__ == '__main__':
    try:        
        query = normalize('NFC', sys.argv[1]).encode('utf-8')
    except:
        query = ""

    data = send_request(query)

    output = []
    tree = ET.fromstring(data)
    success = tree.findtext('.//successYN')
    if success == 'Y':
        for item in tree.findall('newAddressListAreaCdSearchAll'):
            zipNo = item.findtext('.//zipNo')
            lnmAdres = item.findtext('.//lnmAdres')
            rnAdres = item.findtext('.//rnAdres')
            output.append({
                "title": '(' + zipNo + ') ' + lnmAdres,
                "subtitle": rnAdres,
                "valid": True,
                "arg": zipNo
            })
    else:
        output.append({
            'title': tree.findtext('.//errMsg'),
            'valid': False
        });

    rObj = {"items":output}

    print(json.dumps(rObj))